import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class GameMode here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class GameMode extends World
{
    private int row;
    private int column;
    protected int timeCounter;

    private String[] coordinates;
   
    private int pig2SpawnTime = 100;
    private int pig1SpawnTime = 655;
    private int fruitSpawnTime = 210;
    
    private int expireTime;
    
    protected game game;
    protected Hammer hammer;

    /**
     * Constructor
     */
    public GameMode()
    {
        // Create a new world with 500x450 cells with a cell size of 1x1 pixels.
        super(500,450,1);  
    }
    
    public void act()
    {
        // time dalam seconds
        timeCounter++;
        
        if(checkGameOver())
        {
            Greenfoot.setWorld(new EndScreen(game.getScore(), game.getLevel(),1));
        }
            
        if((timeCounter % pig2SpawnTime) == 0 )
        {
            Pig_2 pig_2 = new Pig_2(expireTime);
            spawnTokoh(pig_2);
        }   
        
        if((timeCounter % pig1SpawnTime) == 0 )
        {
            Pig_1 pig_1 = new Pig_1(expireTime);
            spawnTokoh(pig_1);
        }
        
        if((timeCounter % fruitSpawnTime) == 0)
        {
            Fruit fruit = new Fruit(expireTime);
            spawnTokoh(fruit);
        }
        
        // Menampilkan score dan level 
        showText("Score " + game.getScore(), 255, 43);
        showText("Level " + game.getLevel(), 400, 43);
        
        game.setScore(hammer.getScore());
        handleScore();
    }
    
    /**
     * Method untuk handle level 
     */
    private void handleScore()
    {
        if(game.getScore() <= 3)
        {
            game.setLevel(1);
            expireTime = 120;
            pig2SpawnTime = 100;
            pig1SpawnTime = 655;
            fruitSpawnTime = 210;
        }
        else if(game.getScore() >= 4 && game.getScore() <= 9)
        {
            game.setLevel(2);
            expireTime = 110;
            pig2SpawnTime = 90;
            fruitSpawnTime = 190;
        }
        else if(game.getScore() >= 10 && game.getScore() <= 15)
        {
            game.setLevel(3);
            expireTime = 100;
            pig2SpawnTime = 80;
            fruitSpawnTime = 170;
        }
        else if(game.getScore() >= 16 && game.getScore() <= 22)
        {
            game.setLevel(4);
            expireTime = 90;
            pig2SpawnTime = 70;
            fruitSpawnTime = 150;
        }
        else if(game.getScore() >= 23 && game.getScore() <= 29)
        {
            game.setLevel(5);
            expireTime = 80;
            pig1SpawnTime = 60;
            fruitSpawnTime = 130;
        }
        else if(game.getScore() >= 30 && game.getScore() <= 37)
        {
            game.setLevel(6);
            expireTime = 70;
            pig2SpawnTime = 50;
            fruitSpawnTime = 110;
        }
        else if(game.getScore() >= 38 && game.getScore() <= 45)
        {
            game.setLevel(7);
            expireTime = 65;
            pig1SpawnTime = 30;
            fruitSpawnTime = 90;
        }
        else if(game.getScore() >= 46 && game.getScore() <= 54)
        {
            game.setLevel(8);
            expireTime = 60;
            pig2SpawnTime = 25;
            fruitSpawnTime = 65;
        }
        else if(game.getScore() >= 55 && game.getScore() <= 63)
        {
            game.setLevel(9);
            expireTime = 55;
            pig1SpawnTime = 20;
            fruitSpawnTime = 40;
        }
        else if(game.getScore() >= 64)
        {
            game.setLevel(10);
            expireTime = 50;
            pig2SpawnTime = 15;
            fruitSpawnTime = 35;
        }
    }
    
    public void spawnTokoh(Tokoh object)
    {
        int[] coordinates = getRandomCoordinate();
        
        int x = 0;
        while(!getObjectsAt(coordinates[0], coordinates[1], null).isEmpty() || x == 9)
        {
            coordinates = getRandomCoordinate();
            x++;
        }
            
        addObject(object, coordinates[0], coordinates[1]);
    }

    private int[] getRandomCoordinate()
    {
        int[] coordinate = new int[2];
        String coordinateString;
        coordinateString = "" + coordinates[Greenfoot.getRandomNumber(9)];
        
        String[] stringSplit = coordinateString.split(",");
        
        for(int i = 0; i < coordinate.length; i++)
        {
            coordinate[i] = Integer.parseInt(stringSplit[i]);
        }
        
        return coordinate;
    }
    
    public abstract boolean checkGameOver();
    
    /**
     * Inisialisasi
     */
    public void initialize()
    {
        game = new game();
        hammer = new Hammer();
        addObject(hammer, 1,1);
        
        timeCounter = 0;
        expireTime = 120;
        
        
        createCoordinates();
    }

    private void createCoordinates()
    {
        coordinates = new String[9];
        
        coordinates[0] = "90,130";
        coordinates[1] = "239,130";
        coordinates[2] = "385,130";
        coordinates[3] = "90,238";
        coordinates[4] = "239,238";
        coordinates[5] = "385,238";
        coordinates[6] = "90,352";
        coordinates[7] = "239,352";
        coordinates[8] = "385,352";        
    }
}
